package com.vendor.burn.model.struct;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.model.struct.IStruct;
import com.vendor.burn.model.struct.SPartitionItem;

public class SPartitionTable implements IStruct {
  public final int[] szMBR = new int[446];
  
  public final SPartitionItem[] part = new SPartitionItem[4];
  
  public final int[] szValidMark = new int[2];
  
  public SPartitionTable() {
    for (int i = 0; i < this.part.length; i++)
      this.part[i] = new SPartitionItem(); 
  }
  
  public boolean build(int[] data) {
    if (data.length != 512)
      return false; 
    int offset = 0;
    System.arraycopy(data, offset, this.szMBR, 0, this.szMBR.length);
    offset += this.szMBR.length;
    for (SPartitionItem item : this.part) {
      int[] itemdata = new int[16];
      System.arraycopy(data, offset, itemdata, 0, itemdata.length);
      if (!item.build(itemdata))
        return false; 
      offset += itemdata.length;
    } 
    System.arraycopy(data, offset, this.szValidMark, 0, this.szValidMark.length);
    offset += this.szValidMark.length;
    return (offset == data.length);
  }
  
  public int[] getData() {
    int[] data = new int[512];
    int offset = 0;
    System.arraycopy(this.szMBR, 0, data, offset, this.szMBR.length);
    offset += this.szMBR.length;
    for (SPartitionItem item : this.part) {
      int[] idata = item.getData();
      System.arraycopy(idata, 0, data, offset, idata.length);
      offset += idata.length;
    } 
    for (int d : this.szValidMark)
      data[offset++] = d; 
    return data;
  }
}
